Uses crt,graph;
Var i,j,k,gd,gm,x:integer;

    px,py:array[0..3] of integer;
    current:integer;

Const dt = 0.001;
      xsize=25;
      ysize=20;

Type BezierInfo = array[1..4] of
                    record
                          x,y:integer;
                    end;


     PCharDesc = ^TCharDesc;
     TCharDesc = record
                       count:integer;
                       code:byte;
                       sirka,vyska,posun:integer;

                       poly:array[1..80] of BezierInfo;
                 end;

Var poly:BezierInfo;

    chars:array[0..255] of PCharDesc;

    poz,cont,beziers,count:integer;

    f:text;
    free_state:pointer;

    scale:integer;

    name,s:string;


Function I2A(i:integer):string;
Var s:string;
Begin
     Str(i,s);
     I2A:=s;
End;

Function s2i(s:string):integer;
Var v,code:integer;
Begin
     Val(s,v,code);
     s2i:=v;
End;


Procedure DrawBezier(bez:BezierInfo);
Var i:integer;
    t:real;
    b:array[1..4] of real;
    mbx,mby:real;

Begin
     setcolor(lightgray);
     line(bez[1].x,bez[1].y,bez[2].x,bez[2].y);
     line(bez[4].x,bez[4].y,bez[3].x,bez[3].y);

     For i:=1 to 4 do
     Begin
          If i=current+1 then begin setcolor(lightred); setfillstyle(1,lightred); end
                         else begin setcolor(yellow); setfillstyle(1,yellow); end;

          FillEllipse(bez[i].x,bez[i].y,3,3);
     End;

     setcolor(lightgreen);
     setlinestyle(0,0,3);
     t:=0;
     MoveTo(bez[1].x,bez[1].y);

     repeat
           b[1]:=(1-t)*(1-t)*(1-t);
           b[2]:=3*t*(1-t)*(1-t);
           b[3]:=3*t*t*(1-t);
           b[4]:=t*t*t;

           mbx:=bez[1].x*b[1]+bez[2].x*b[2]+bez[3].x*b[3]+bez[4].x*b[4];
           mby:=bez[1].y*b[1]+bez[2].y*b[2]+bez[3].y*b[3]+bez[4].y*b[4];

           LineTo(round(mbx),round(mby));

           t:=t+dt;
     until t>1;
     setlinestyle(0,0,1);
End;

Procedure Grid;
Var x:integer;
Begin
     setcolor(white);

     settextjustify(centertext,toptext);

     For x:=0 to xsize do
     Begin
          line(50+x*20,50,50+x*20,50+20*ysize);
          If not odd(x) then outtextxy(50+x*20,40,i2a(x));
     End;


     settextjustify(righttext,centertext);

     For x:=0 to ysize do
     Begin
          line(50,50+x*20,50+20*xsize,50+x*20);
          If not odd(x) then outtextxy(48,50+20*x,i2a(x));
     End;
End;


procedure waitretrace; assembler;
asm
      mov dx,3dah

@1:   in al,dx
      test al,8
      jnz @1

@2:   in al,dx
      test al,8
      jz @2
end;

Begin
     gd:=detect;
     {$IFDEF ___HOME}
     initgraph(gd,gm,'e:\bp\bgi');
     {$ELSE}
     initgraph(gd,gm,'s:\prog\tp7\bgi');
     {$ENDIF}

     current:=0;

     scale:=4;
     name:='export.exp';

     For i:=1 to paramcount do
     Begin
          s:=paramstr(i);
          If s[1]='-' then scale:=s2i(copy(s,2,255))
                      else name:=s;
     End;

     assign(f,name);
     reset(f);

     read(f,count);

     Mark(free_state);

     For i:=0 to count-1 do
     Begin
          New(chars[i]);
          read(f,chars[i]^.code);
          read(f,chars[i]^.sirka,chars[i]^.vyska,chars[i]^.posun);

          poz:=0;

          read(f,cont);
          For j:=1 to cont do
          Begin
               read(f,beziers);
               For k:=1 to beziers do
               Begin
                    inc(poz);
                    read(f,chars[i]^.poly[poz][1].x,chars[i]^.poly[poz][1].y,
                           chars[i]^.poly[poz][2].x,chars[i]^.poly[poz][2].y,
                           chars[i]^.poly[poz][3].x,chars[i]^.poly[poz][3].y,
                           chars[i]^.poly[poz][4].x,chars[i]^.poly[poz][4].y);

                    chars[i]^.poly[poz][1].x:=50+chars[i]^.poly[poz][1].x div scale;
                    chars[i]^.poly[poz][1].y:=460-(chars[i]^.poly[poz][1].y div scale);
                    chars[i]^.poly[poz][2].x:=50+chars[i]^.poly[poz][2].x div scale;
                    chars[i]^.poly[poz][2].y:=460-(chars[i]^.poly[poz][2].y div scale);
                    chars[i]^.poly[poz][3].x:=50+chars[i]^.poly[poz][3].x div scale;
                    chars[i]^.poly[poz][3].y:=460-(chars[i]^.poly[poz][3].y div scale);
                    chars[i]^.poly[poz][4].x:=50+chars[i]^.poly[poz][4].x div scale;
                    chars[i]^.poly[poz][4].y:=460-(chars[i]^.poly[poz][4].y div scale);
               End;
          End;

          chars[i]^.count:=poz;
     End;


     repeat
           waitretrace;
           cleardevice;

           For i:=1 to chars[current]^.count do
           Begin
                DrawBezier(chars[current]^.poly[i]);
           End;

           setcolor(15);
           setlinestyle(0,0,1);
           line(0,460-(-chars[current]^.posun div scale),639,460-(-chars[current]^.posun div scale));
           line(50,0,50,479);
           line(50+(chars[current]^.sirka div scale),0,50+(chars[current]^.sirka div scale),479);

           outtextxy(500,20,'character '+i2a(chars[current]^.code)+' ('+char(chars[current]^.code)+')');

           case readkey of
                #27 : break;
                '6' : Begin
                           inc(current,10);
                           if current>count-1 then current:=count-1;
                      End;
                '4' : Begin
                           dec(current,10);
                           if current<0 then current:=0;
                      End;
                #0  : case readkey of
                          #75: If current>0 then dec(current);
                          #77: If current<count-1 then inc(current);
                      end;
           end;

           mem[$0:$41C]:=mem[$0:$041A];
     until false;

     closegraph;

     release(free_state);
End.